Index: src/org/mifos/application/reports/business/service/IReportsParameterService.java
===================================================================
--- src/org/mifos/application/reports/business/service/IReportsParameterService.java	(revision 0)
+++ src/org/mifos/application/reports/business/service/IReportsParameterService.java	(revision 0)
@@ -0,0 +1,29 @@
+package org.mifos.application.reports.business.service;
+
+import java.util.Date;
+import java.util.List;
+
+import org.mifos.application.customer.util.helpers.CustomerLevel;
+import org.mifos.application.reports.ui.DateSelectionItem;
+import org.mifos.application.reports.ui.SelectionItem;
+import org.mifos.framework.exceptions.PersistenceException;
+
+
+public interface IReportsParameterService {
+
+	public abstract List<SelectionItem> getActiveBranchesUnderUser(
+			String officeSearchId) throws PersistenceException;
+
+	public abstract List<SelectionItem> getActiveLoanOfficersUnderOffice(
+			Short branchId) throws PersistenceException;
+
+	public abstract List<SelectionItem> getActiveCentersUnderUser(
+			Short branchId, Short loanOfficerId) throws PersistenceException;
+
+	public abstract List<DateSelectionItem> getMeetingDates(Short branchId,
+			Short loanOfficerId, Integer centerId, CustomerLevel customerLevel, Date from)
+			throws PersistenceException;
+
+	public abstract List<SelectionItem> getActiveGroupsUnderUser(Short branchId,
+			Short loanOfficerId) throws PersistenceException;
+}
Index: src/org/mifos/application/reports/business/service/ICollectionSheetReportService.java
===================================================================
--- src/org/mifos/application/reports/business/service/ICollectionSheetReportService.java	(revision 0)
+++ src/org/mifos/application/reports/business/service/ICollectionSheetReportService.java	(revision 0)
@@ -0,0 +1,43 @@
+package org.mifos.application.reports.business.service;
+
+import java.util.Date;
+import java.util.List;
+
+import org.mifos.application.customer.util.helpers.CustomerLevel;
+import org.mifos.application.reports.business.dto.CollectionSheetReportDTO;
+import org.mifos.application.reports.ui.DateSelectionItem;
+import org.mifos.application.reports.ui.SelectionItem;
+import org.mifos.framework.exceptions.PersistenceException;
+import org.mifos.framework.exceptions.ServiceException;
+
+
+public interface ICollectionSheetReportService {
+
+	public abstract List<SelectionItem> getBranchOffices(Integer userId)
+			throws ServiceException, PersistenceException;
+
+	public abstract List<SelectionItem> getActiveLoanOfficers(Integer userId,
+			Integer branchIdIntValue) throws ServiceException,
+			PersistenceException;
+
+	public abstract List<SelectionItem> getActiveCentersForLoanOfficer(
+			Integer loanOfficerIdIntValue, Integer branchIdIntValue)
+			throws ServiceException, PersistenceException;
+
+	public abstract List<SelectionItem> getActiveGroupsForLoanOfficer(
+			Integer loanOfficerId, Integer branchId) throws ServiceException,
+			PersistenceException;
+
+	public abstract List<CollectionSheetReportDTO> getCollectionSheets(
+			Integer branchId, Integer officerId, Integer centerId,
+			Date meetingDate, Integer customerLevel) throws Exception;
+
+	public List<DateSelectionItem> getMeetingDatesForGroup(Integer branchId,
+			Integer groupId, Integer officerId) throws PersistenceException,
+			ServiceException;
+
+	public List<DateSelectionItem> getMeetingDatesForCenter(Integer branchId,
+			Integer groupId, Integer officerId) throws PersistenceException,
+			ServiceException;
+
+}
Index: src/org/mifos/application/reports/business/service/ReportProductOfferingService.java
===================================================================
--- src/org/mifos/application/reports/business/service/ReportProductOfferingService.java	(revision 0)
+++ src/org/mifos/application/reports/business/service/ReportProductOfferingService.java	(revision 0)
@@ -0,0 +1,54 @@
+package org.mifos.application.reports.business.service;
+
+import java.io.IOException;
+import java.util.Properties;
+
+import org.mifos.application.reports.exceptions.ReportServiceInitializationException;
+import org.mifos.framework.util.helpers.FilePaths;
+
+public class ReportProductOfferingService {
+
+	private static final String LOAN_PRODUCT_IDS = "loan.product.ids";
+	private static final String SAVINGS_PRODUCT_IDS = "savings.product.ids";
+	private static final String IDS_DELIMITER = "\\s*,\\s*";
+	
+	private String[] configuredSavingProducts;
+	private String[] configuredLoanProducts;
+
+	public ReportProductOfferingService() {
+		try {
+			init();
+		}
+		catch (IOException e) {
+			throw new ReportServiceInitializationException("Failed to initialize Report Product Offering Service", e);
+		}
+	}
+
+	public void init() throws IOException {
+		Properties properties = new Properties();
+		properties
+				.load(getClass()
+						.getResourceAsStream(
+								FilePaths.REPORT_PRODUCT_OFFERING_CONFIG));
+		configuredSavingProducts = properties
+				.getProperty(SAVINGS_PRODUCT_IDS).split(IDS_DELIMITER);
+		configuredLoanProducts = properties.getProperty(LOAN_PRODUCT_IDS)
+				.split(IDS_DELIMITER);
+	}
+
+	public Short getLoanProduct1() {
+		return Short.valueOf(configuredLoanProducts[0]);
+	}
+	
+	public Short getLoanProduct2() {
+		return Short.valueOf(configuredLoanProducts[1]);
+	}
+
+	public Short getSavingsProduct1() {
+		return Short.valueOf(configuredSavingProducts[0]);
+	}
+
+	public Short getSavingsProduct2() {
+		return Short.valueOf(configuredSavingProducts[1]);
+	}
+}
Index: src/org/mifos/application/reports/business/NameValuePair.java
===================================================================
--- src/org/mifos/application/reports/business/NameValuePair.java	(revision 0)
+++ src/org/mifos/application/reports/business/NameValuePair.java	(revision 0)
@@ -0,0 +1,20 @@
+package org.mifos.application.reports.business;
+
+public class NameValuePair {
+	private final String name;
+	private final String value;
+
+	public NameValuePair(String name, String value) {
+		super();
+		this.name = name;
+		this.value = value;
+	}
+
+	public String getName() {
+		return name;
+	}
+
+	public String getValue() {
+		return value;
+	}
+}
Index: src/org/mifos/application/reports/util/helpers/ReportsConstants.java
===================================================================
--- src/org/mifos/application/reports/util/helpers/ReportsConstants.java	(revision 12247)
+++ src/org/mifos/application/reports/util/helpers/ReportsConstants.java	(working copy)
@@ -38,6 +38,8 @@
 
 package org.mifos.application.reports.util.helpers;
 
+import java.util.Date;
+
 public interface ReportsConstants {
 	public String GETPATH_REPORTS="reportsAction";
 	public String GETREPORTPAGE="getReportPage";
@@ -81,6 +83,13 @@
 	public static final String ERROR_REPORTALREADYEXIST="error.reportAlreadyExist";
 	public static final String ERROR_REPORTACTIVITYIDISNULL="error.reportActivityIdIsNull";
 	public static final String ERROR_NOMOREDYNAMICACTIVITYID="error.noMoreDynamicActivityId";
-	
-	
+//added by collection sheet report module
+	public static final String SELECT_DISPLAY_NAME = "---Select---";
+	public static final String NOT_APPLICABLE_DISPLAY_NAME = "---N/A---";
+	public static final String ALL_DISPLAY_NAME = "ALL";
+	public static final Short NOT_APPLICABLE_ID = new Short("-3");
+	public static final Short SELECT_ID = new Short("-2");
+	public static final Short ALL_ID = new Short("-1");
+	public static final Date NA_DATE = new Date(0l);
+//ended by collection sheet report module
 }
Index: src/org/mifos/application/reports/util/helpers/CollectionSheetReportConstants.java
===================================================================
--- src/org/mifos/application/reports/util/helpers/CollectionSheetReportConstants.java	(revision 0)
+++ src/org/mifos/application/reports/util/helpers/CollectionSheetReportConstants.java	(revision 0)
@@ -0,0 +1,18 @@
+package org.mifos.application.reports.util.helpers;
+
+
+
+public class CollectionSheetReportConstants {
+
+	public static final String LOAN_OFFICER_ID_INVALID_MSG = "loanOfficerId.invalid";
+	public static final String CENTER_ID_INVALID_MSG = "centerId.invalid";
+	public static final String MEETING_DATE_INVALID_MSG = "meetingDate.invalid";
+	
+	public static final String BRANCH_ID_PARAM = "branchId";
+	public static final String LOAN_OFFICER_ID_PARAM = "loanOfficerId";
+	public static final String CENTER_ID_PARAM = "centerId";
+	public static final String MEETING_DATE_PARAM = "meetingDate";
+	public static final String[] REPORT_PARAMS_ARRAY = {BRANCH_ID_PARAM, LOAN_OFFICER_ID_PARAM, CENTER_ID_PARAM, 
+		MEETING_DATE_PARAM};
+
+}
Index: src/org/mifos/application/reports/action/BirtReportValidationAction.java
===================================================================
--- src/org/mifos/application/reports/action/BirtReportValidationAction.java	(revision 0)
+++ src/org/mifos/application/reports/action/BirtReportValidationAction.java	(revision 0)
@@ -0,0 +1,68 @@
+package org.mifos.application.reports.action;
+
+import java.io.IOException;
+import java.util.HashMap;
+import java.util.Map;
+
+import javax.servlet.ServletException;
+import javax.servlet.http.HttpServlet;
+import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletResponse;
+
+import org.mifos.application.reports.business.ReportParameterForm;
+import org.mifos.application.reports.business.validator.CollectionSheetReportParamValidator;
+import org.mifos.application.reports.business.validator.DetailedAgingPortfolioReportParamValidator;
+import org.mifos.application.reports.business.validator.Errors;
+import org.mifos.application.reports.business.validator.ReportParameterValidator;
+import org.mifos.framework.security.util.UserContext;
+import org.mifos.framework.servlet.ModifiableParameterServletRequest;
+
+public class BirtReportValidationAction extends HttpServlet {
+
+	private static final String ERRORS = "reportErrors";
+	private static Map<String, ReportParameterValidator<ReportParameterForm>> reportValidators = new HashMap<String, ReportParameterValidator<ReportParameterForm>>();
+
+	static {
+		reportValidators.put("report/LayoutReport.rptdesign",
+				CollectionSheetReportParamValidator.INSTANCE);
+		reportValidators.put("report/DetailedAgingPortfolioAtRisk.rptdesign", 
+				DetailedAgingPortfolioReportParamValidator.INSTANCE);
+		reportValidators.put("report/ActiveLoansByLoanOfficer.rptdesign", 
+				DetailedAgingPortfolioReportParamValidator.INSTANCE);		
+	}
+
+	@Override
+	protected void doGet(HttpServletRequest request,
+			HttpServletResponse response) throws ServletException, IOException {
+		validateReportParameters(request, response);
+	}
+
+	@Override
+	protected void doPost(HttpServletRequest request,
+			HttpServletResponse response) throws ServletException, IOException {
+		doGet(request, response);
+	}
+
+	private void validateReportParameters(HttpServletRequest request,
+			HttpServletResponse response) throws ServletException, IOException {
+		ReportParameterValidator validator = reportValidators.get(request
+				.getParameter("__report"));
+		if (validator == null || request.getParameter("branchId") == null) {
+			request.getRequestDispatcher("/run").forward(request, response);
+			return;
+		}
+
+		ReportParameterForm form = validator.buildReportParameterForm(request);
+		Errors errors = new Errors(((UserContext) request.getSession()
+				.getAttribute("UserContext")).getPreferredLocale());
+		validator.validate(form, errors);
+		ModifiableParameterServletRequest modifiedRequest = new ModifiableParameterServletRequest(
+				request);
+
+		if (errors.hasErrors()) {
+			request.setAttribute(ERRORS, errors);
+			validator.removeRequestParameters(modifiedRequest, form, errors);
+		}
+		request.getRequestDispatcher("/run").forward(modifiedRequest, response);
+	}
+}
Index: src/org/mifos/application/reports/ui/DateSelectionItem.java
===================================================================
--- src/org/mifos/application/reports/ui/DateSelectionItem.java	(revision 0)
+++ src/org/mifos/application/reports/ui/DateSelectionItem.java	(revision 0)
@@ -0,0 +1,80 @@
+package org.mifos.application.reports.ui;
+
+import static org.mifos.application.reports.util.helpers.ReportsConstants.NA_DATE;
+import static org.mifos.application.reports.util.helpers.ReportsConstants.NOT_APPLICABLE_DISPLAY_NAME;
+
+import java.io.Serializable;
+import java.text.DateFormat;
+import java.text.SimpleDateFormat;
+import java.util.Date;
+
+import org.mifos.framework.util.LocalizationConverter;
+
+public class DateSelectionItem implements Serializable {
+
+	private static final SimpleDateFormat DEFAULT_DATE_FORMAT = new SimpleDateFormat(
+			"dd/MM/yyyy");
+	public static final DateSelectionItem NA_MEETING_DATE = new DateSelectionItem(
+			NA_DATE, NOT_APPLICABLE_DISPLAY_NAME);
+
+	private Date date;
+	private String displayDate;
+	// For Hibernate
+	public DateSelectionItem() {
+		super();
+	}
+
+	public DateSelectionItem(Date date) {
+		this.date = date;
+	}
+
+	public DateSelectionItem(Date date, String display) {
+		this.date = date;
+		this.displayDate = display;
+	}
+
+	private DateFormat getDateFormat() {
+		DateFormat dateFormat;
+		try {
+			dateFormat = LocalizationConverter.getInstance().getDateFormat();
+		}
+		catch (RuntimeException e) {
+			dateFormat = DEFAULT_DATE_FORMAT;
+		}
+		return dateFormat;
+	}
+
+	public Date getDate() {
+		return date;
+	}
+
+	public String getDisplayDate() {
+		return displayDate != null ? displayDate : getDateFormat().format(date);
+	}
+
+	@Override
+	public int hashCode() {
+		final int PRIME = 31;
+		int result = 1;
+		result = PRIME * result + ((date == null) ? 0 : date.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		final DateSelectionItem other = (DateSelectionItem) obj;
+		if (date == null) {
+			if (other.date != null)
+				return false;
+		}
+		else if (!date.equals(other.date))
+			return false;
+		return true;
+	}
+}
Index: src/org/mifos/application/reports/ui/SelectionItem.java
===================================================================
--- src/org/mifos/application/reports/ui/SelectionItem.java	(revision 0)
+++ src/org/mifos/application/reports/ui/SelectionItem.java	(revision 0)
@@ -0,0 +1,101 @@
+package org.mifos.application.reports.ui;
+
+import static org.mifos.application.reports.util.helpers.ReportsConstants.ALL_DISPLAY_NAME;
+import static org.mifos.application.reports.util.helpers.ReportsConstants.ALL_ID;
+import static org.mifos.application.reports.util.helpers.ReportsConstants.NOT_APPLICABLE_DISPLAY_NAME;
+import static org.mifos.application.reports.util.helpers.ReportsConstants.NOT_APPLICABLE_ID;
+import static org.mifos.application.reports.util.helpers.ReportsConstants.SELECT_DISPLAY_NAME;
+import static org.mifos.application.reports.util.helpers.ReportsConstants.SELECT_ID;
+import static org.mifos.framework.util.helpers.NumberUtils.convertIntegerToShort;
+
+import java.io.Serializable;
+
+public class SelectionItem implements Serializable {
+	public static final SelectionItem ALL_LOAN_OFFICER_SELECTION_ITEM = new SelectionItem(
+			ALL_ID, ALL_DISPLAY_NAME);
+	public static final SelectionItem SELECT_LOAN_OFFICER_SELECTION_ITEM = new SelectionItem(
+			SELECT_ID, SELECT_DISPLAY_NAME);
+	public static final SelectionItem NA_LOAN_OFFICER_SELECTION_ITEM = new SelectionItem(
+			NOT_APPLICABLE_ID, NOT_APPLICABLE_DISPLAY_NAME);
+
+	public static final SelectionItem SELECT_BRANCH_OFFICE_SELECTION_ITEM = new SelectionItem(
+			SELECT_ID, SELECT_DISPLAY_NAME);
+	public static final SelectionItem NA_BRANCH_OFFICE_SELECTION_ITEM = new SelectionItem(
+			NOT_APPLICABLE_ID, NOT_APPLICABLE_DISPLAY_NAME);
+	public static final SelectionItem ALL_CENTER_SELECTION_ITEM = new SelectionItem(ALL_ID,
+			ALL_DISPLAY_NAME);
+	public static final SelectionItem NA_CENTER_SELECTION_ITEM = new SelectionItem(
+			NOT_APPLICABLE_ID, NOT_APPLICABLE_DISPLAY_NAME);
+	public static final SelectionItem SELECT_CENTER_SELECTION_ITEM = new SelectionItem(
+			SELECT_ID, SELECT_DISPLAY_NAME);
+	
+	public static final SelectionItem SELECT_GROUP_SELECTION_ITEM = new SelectionItem(
+			SELECT_ID, SELECT_DISPLAY_NAME);	
+	public static final SelectionItem NA_GROUP_SELECTION_ITEM = new SelectionItem(
+			NOT_APPLICABLE_ID,NOT_APPLICABLE_DISPLAY_NAME);	
+	public static final SelectionItem ALL_GROUP_SELECTION_ITEM = new SelectionItem(
+			ALL_ID, ALL_DISPLAY_NAME);	
+
+	private String displayName;
+	private Short id;
+
+	public SelectionItem(Short id, String displayName) {
+		super();
+		this.displayName = displayName;
+		this.id = id;
+	}
+
+	public SelectionItem() {
+		super();
+	}
+
+	public Short getId() {
+		return id;
+	}
+
+	public String getDisplayName() {
+		return displayName;
+	}
+
+	@Override
+	public int hashCode() {
+		final int PRIME = 31;
+		int result = 1;
+		result = PRIME * result + ((displayName == null) ? 0 : displayName.hashCode());
+		result = PRIME * result + ((id == null) ? 0 : id.hashCode());
+		return result;
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+		if (this == obj)
+			return true;
+		if (obj == null)
+			return false;
+		if (getClass() != obj.getClass())
+			return false;
+		final SelectionItem other = (SelectionItem) obj;
+		if (displayName == null) {
+			if (other.displayName != null)
+				return false;
+		}
+		else if (!displayName.equals(other.displayName))
+			return false;
+		if (id == null) {
+			if (other.id != null)
+				return false;
+		}
+		else if (!id.equals(other.id))
+			return false;
+		return true;
+	}
+
+	public boolean sameAs(Integer id) {
+		return this.id.equals(convertIntegerToShort(id));
+	}
+
+	public boolean sameAs(Short id) {
+		return this.id.equals(id);
+	}
+
+}
Index: src/org/mifos/application/customer/center/business/CenterBO.java
===================================================================
--- src/org/mifos/application/customer/center/business/CenterBO.java	(revision 12247)
+++ src/org/mifos/application/customer/center/business/CenterBO.java	(working copy)
@@ -10,6 +10,7 @@
 import org.mifos.application.configuration.exceptions.ConfigurationException;
 import org.mifos.application.configuration.util.helpers.ConfigurationConstants;
 import org.mifos.application.customer.business.CustomerBO;
+import org.mifos.application.customer.business.CustomerLevelEntity;
 import org.mifos.application.customer.business.CustomerPerformanceHistory;
 import org.mifos.application.customer.business.CustomerPositionView;
 import org.mifos.application.customer.center.persistence.CenterPersistence;
@@ -23,6 +24,7 @@
 import org.mifos.application.fees.business.FeeView;
 import org.mifos.application.master.business.CustomFieldView;
 import org.mifos.application.meeting.business.MeetingBO;
+import org.mifos.application.personnel.business.PersonnelBO;
 import org.mifos.framework.business.util.Address;
 import org.mifos.framework.components.logger.LoggerConstants;
 import org.mifos.framework.components.logger.MifosLogManager;
@@ -33,7 +35,6 @@
 public class CenterBO extends CustomerBO {
 
 	private MifosLogger logger = MifosLogManager.getLogger(LoggerConstants.CENTERLOGGER);
-	
 	public CenterBO(UserContext userContext, String displayName,
 			Address address, List<CustomFieldView> customFields,
 			List<FeeView> fees, String externalId, Date mfiJoiningDate,
@@ -59,6 +60,10 @@
 		super();
 	}
 	
+	public CenterBO(Integer customerId, CustomerLevelEntity customerLevel, PersonnelBO formedByPersonnel, PersonnelBO personnel, String displayName) {
+		super(customerId, customerLevel, formedByPersonnel, personnel, displayName);
+	}
+	
 	@Override
 	public boolean isActive() {
 		return getStatus() == CustomerStatus.CENTER_ACTIVE;
Index: src/org/mifos/application/customer/business/CustomerBO.java
===================================================================
--- src/org/mifos/application/customer/business/CustomerBO.java	(revision 12247)
+++ src/org/mifos/application/customer/business/CustomerBO.java	(working copy)
@@ -152,13 +152,21 @@
 	private Set<CustomerBO> children;
 
 	protected CustomerBO() {
-		super();
-		this.customerId = null;
+		this(null, null, null, null, null);
 		this.globalCustNum = null;
-		this.customerLevel = null;
-		this.formedByPersonnel = null;
 	}
 
+	
+	public CustomerBO(Integer customerId, CustomerLevelEntity customerLevel, PersonnelBO formedByPersonnel, PersonnelBO personnel, String displayName) {
+		super();
+		this.customerId = customerId;
+		this.customerLevel = customerLevel;
+		this.formedByPersonnel = formedByPersonnel;
+		this.personnel = personnel;
+		this.displayName = displayName;
+	}
+
+
 	protected CustomerBO(UserContext userContext, String displayName,
 			CustomerLevel customerLevel, CustomerStatus customerStatus,
 			String externalId, Date mfiJoiningDate, Address address,
Index: src/org/mifos/application/customer/group/business/GroupBO.java
===================================================================
--- src/org/mifos/application/customer/group/business/GroupBO.java	(revision 12247)
+++ src/org/mifos/application/customer/group/business/GroupBO.java	(working copy)
@@ -47,6 +47,7 @@
 import org.mifos.application.configuration.util.helpers.ConfigurationConstants;
 import org.mifos.application.customer.business.CustomerBO;
 import org.mifos.application.customer.business.CustomerHierarchyEntity;
+import org.mifos.application.customer.business.CustomerLevelEntity;
 import org.mifos.application.customer.business.CustomerPositionView;
 import org.mifos.application.customer.business.CustomerStatusEntity;
 import org.mifos.application.customer.center.business.CenterBO;
@@ -64,10 +65,10 @@
 import org.mifos.application.meeting.business.MeetingBO;
 import org.mifos.application.office.business.OfficeBO;
 import org.mifos.application.office.persistence.OfficePersistence;
+import org.mifos.application.personnel.business.PersonnelBO;
 import org.mifos.application.util.helpers.YesNoFlag;
 import org.mifos.config.ClientRules;
 import org.mifos.framework.business.util.Address;
-import org.mifos.framework.components.configuration.business.Configuration;
 import org.mifos.framework.components.logger.LoggerConstants;
 import org.mifos.framework.components.logger.MifosLogManager;
 import org.mifos.framework.components.logger.MifosLogger;
@@ -131,6 +132,10 @@
 				officeId, parentCustomer, meeting, loanOfficerId);
 		validateFields(displayName, formedById, trained, trainedDate);
 	}
+	
+	public GroupBO(int customerId, CustomerLevelEntity customerLevel, PersonnelBO formedByPersonnel, PersonnelBO personnel, String displayName) {
+		super(customerId, customerLevel, formedByPersonnel, personnel, displayName);
+	}	
 
 	@Override
 	public boolean isActive() {
Index: src/org/mifos/application/personnel/business/PersonnelBO.java
===================================================================
--- src/org/mifos/application/personnel/business/PersonnelBO.java	(revision 12247)
+++ src/org/mifos/application/personnel/business/PersonnelBO.java	(working copy)
@@ -1,5 +1,7 @@
 package org.mifos.application.personnel.business;
 
+import static org.mifos.application.reports.util.helpers.ReportsConstants.*;
+
 import java.util.ArrayList;
 import java.util.Date;
 import java.util.HashSet;
@@ -20,6 +22,7 @@
 import org.mifos.application.personnel.util.helpers.PersonnelConstants;
 import org.mifos.application.personnel.util.helpers.PersonnelLevel;
 import org.mifos.application.personnel.util.helpers.PersonnelStatus;
+import org.mifos.application.reports.util.helpers.ReportsConstants;
 import org.mifos.application.rolesandpermission.business.RoleBO;
 import org.mifos.config.Localization;
 import org.mifos.framework.business.BusinessObject;
@@ -85,7 +88,7 @@
 	private Set<PersonnelNotesEntity> personnelNotes;
 
 	private MifosLogger logger = MifosLogManager.getLogger(LoggerConstants.PERSONNEL_LOGGER);
-	
+
 	public static PersonnelBO ALL_PERSONNEL = new PersonnelBO();
 	static {
 		ALL_PERSONNEL.setDisplayName("ALL");
@@ -139,15 +142,20 @@
 	}
 
 	PersonnelBO() {
-		this.level = null;
+		this(null, null, null, null);
 		this.personnelDetails = new PersonnelDetailsEntity();
 		this.preferredLocale = new SupportedLocalesEntity();
 		this.customFields = new HashSet<PersonnelCustomFieldEntity>();
 		this.personnelNotes = new HashSet<PersonnelNotesEntity>();
-		this.personnelId = null;
-		this.userName = null;
 	}
 
+	public PersonnelBO(Short personnelId, String userName, String displayName, PersonnelLevelEntity level) {
+		this.personnelId = personnelId;
+		this.userName = userName;
+		this.displayName = displayName;
+		this.level = level;
+	}
+
 	public String getAge() {
 		if (this.personnelDetails != null
 				&& this.personnelDetails.getDob() != null
Index: src/org/mifos/application/personnel/business/PersonnelLevelEntity.java
===================================================================
--- src/org/mifos/application/personnel/business/PersonnelLevelEntity.java	(revision 12247)
+++ src/org/mifos/application/personnel/business/PersonnelLevelEntity.java	(working copy)
@@ -12,6 +12,9 @@
 
 	private final PersonnelLevelEntity parent;
 
+	public static final PersonnelLevelEntity NON_LOAN_OFFICER_LEVEL_ENTITY = new PersonnelLevelEntity(
+			PersonnelLevel.NON_LOAN_OFFICER);
+
 	public PersonnelLevelEntity(PersonnelLevel level) {
 		super(level.getValue());
 		this.parent = null;
@@ -31,8 +34,8 @@
 		return parent;
 	}
 
-    @Override
+	@Override
 	public String toString() {
-        return PersonnelLevel.fromInt(getId()).toString();
-    }
+		return PersonnelLevel.fromInt(getId()).toString();
+	}
 }
Index: src/org/mifos/doc-root/application/reports/jsp/birtReport.jsp
===================================================================
--- src/org/mifos/doc-root/application/reports/jsp/birtReport.jsp	(revision 12247)
+++ src/org/mifos/doc-root/application/reports/jsp/birtReport.jsp	(working copy)
@@ -5,6 +5,6 @@
 
 <tiles:insert definition=".reportRender">
 <tiles:put name="body" type="string">
-    <iframe style="border:none; padding:0px;" width="1024px" height="100%" frameborder=0 src="<c:url value='/run' />?__report=report/<c:out value='${reportFile}' />&reportName=<c:out value='${reportName}' />&userId=<c:out value='${sessionScope.UserContext.id}'/>&__format=pdf"></iframe>
+	<iframe style="border:none; padding:0px;" width="1024px" height="100%" frameborder=0 src="<c:url value='/birtReports' />?__report=report/<c:out value='${reportFile}' />&reportName=<c:out value='${reportName}' />&userId=<c:out value='${sessionScope.UserContext.id}'/>&__format=pdf"></iframe>
 </tiles:put>
 </tiles:insert>
Index: src/org/mifos/framework/persistence/DatabaseVersionPersistence.java
===================================================================
--- src/org/mifos/framework/persistence/DatabaseVersionPersistence.java	(revision 12247)
+++ src/org/mifos/framework/persistence/DatabaseVersionPersistence.java	(working copy)
@@ -16,7 +16,7 @@
 import org.mifos.application.accounts.util.helpers.AccountActionTypes;
 import org.mifos.application.accounts.util.helpers.AccountStateFlag;
 import org.mifos.application.holiday.persistence.Upgrade104;
-import org.mifos.application.master.persistence.Upgrade167;
+//import org.mifos.application.master.persistence.Upgrade167;
 import org.mifos.application.master.persistence.Upgrade169;
 import org.mifos.application.productsmix.persistence.Upgrade127;
 import org.mifos.application.reports.business.ReportsCategoryBO;
@@ -67,7 +67,7 @@
 		register144(register);
 		register145(register);
 		register146(register);
-		register(register, new Upgrade167());
+//		register(register, new Upgrade167());
 		register(register, new Upgrade169());
 		return Collections.unmodifiableMap(register);
 	}
Index: src/org/mifos/framework/servlet/ModifiableParameterServletRequest.java
===================================================================
--- src/org/mifos/framework/servlet/ModifiableParameterServletRequest.java	(revision 0)
+++ src/org/mifos/framework/servlet/ModifiableParameterServletRequest.java	(revision 0)
@@ -0,0 +1,68 @@
+package org.mifos.framework.servlet;
+
+import java.util.ArrayList;
+import java.util.Enumeration;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import javax.servlet.http.HttpServletRequest;
+import javax.servlet.http.HttpServletRequestWrapper;
+
+import org.apache.commons.collections.iterators.IteratorEnumeration;
+@SuppressWarnings("deprecation")
+public class ModifiableParameterServletRequest extends
+		HttpServletRequestWrapper {
+	List<String> removedParameterList;
+
+	public ModifiableParameterServletRequest(HttpServletRequest originalRequest) {
+		super(originalRequest);
+		removedParameterList = new ArrayList<String>();
+	}
+
+	public void removeParameter(String string) {
+		removedParameterList.add(string);
+	}
+
+	@Override
+	public String getParameter(String arg0) {
+		if (removedParameterList.contains(arg0))
+			return null;
+		return getRequest().getParameter(arg0);
+	}
+
+	@Override
+	public Map getParameterMap() {
+		Map parameterMap = updatedParameterList();
+		return parameterMap;
+	}
+
+	private Map<String, String> updatedParameterList() {
+		Map<String, String> parameterMap = new HashMap<String, String>(
+				getRequest().getParameterMap());
+		for (String removeParameterName : removedParameterList) {
+			parameterMap.remove(removeParameterName);
+		}
+		return parameterMap;
+	}
+
+	@Override
+	public Enumeration getParameterNames() {
+		Enumeration parameterNames = getRequest().getParameterNames();
+		List paramNames = new ArrayList();
+		while (parameterNames.hasMoreElements()) {
+			Object nextElement = parameterNames.nextElement();
+			if (!removedParameterList.contains(nextElement)) {
+				paramNames.add(nextElement);
+			}
+		}
+		return new IteratorEnumeration(paramNames.iterator());
+	}
+
+	@Override
+	public String[] getParameterValues(String arg0) {
+		if (removedParameterList.contains(arg0))
+			return null;
+		return getRequest().getParameterValues(arg0);
+	}
+}
